function [beta_mean,sigma_mean,df_mean,beta_std,sigma_std,df_std]=GIBBS_CT_SUR(Y1,X1,Y2,X2,Y3,X3,Y4,X4,Y5,X5,Y6,X6,Y7,X7)

% ĹtֲSURϵͳıҶ˹
% ڼ˹мM-HԪأɶȳ
%  M-H ԾܶѡΪֲ̬Ӧ

% ģΪ:  Y1t = X1t 1 + Wt +1t
%          Y2t = X2t 2 + Wt +2t
% Ӻ߶Ȳtֲ tt(0,,df)

% beta_rec          Ըϵֲ
% sigma_rec         ԸŶЭֲ
% df_rec            ɶȺֲ


if floor(nargin/2) ~= nargin/2
    disp('Error: X,Y not match')
end

% ͶѻSUR(ȶѻ̣ٶѻ)
neq = nargin/2;
nobs = length(Y1);

X_cell = cell(neq,1);
Y_mat = zeros(neq,nobs);
nreg_eq = zeros(neq,1);
for m = 1:neq
    Y_mat(m,:) = eval(['Y',num2str(m)]);
    X_cell{m} = eval(['X',num2str(m)]);
    nreg_eq(m) = length(eval(['X',num2str(m),'(1,:)']));
end
Y_SUR = Y_mat(:);
nreg_cum = cumsum(nreg_eq);
nreg_sum = nreg_cum(end);

X_SUR = zeros(nobs*neq,nreg_sum);
X_use = zeros(neq,nreg_cum(end));
for n = 1:nobs
    X_use(1,1:nreg_eq(1)) = X_cell{1}(n,:);
    for m = 2:neq
        X_use(m,nreg_cum(m-1) + 1:nreg_cum(m)) = X_cell{m}(n,:);
    end
    X_SUR((n-1)*neq + 1:n*neq,:) = X_use;
end


%----------------------------------------
% GIBBSմڴ˴
ndraws = 30000;
burn_in = ndraws*0.1;

%----------------------------------------
% ģ͵ֲ趨Ϊ
%   ~ N(mu,V)
%   ~ W(,df)
% ڴ˴ֲĲ(ܸķֲ)

prior_mu = zeros(nreg_sum,1);
prior_V = 10*eye(nreg_sum);
prior_omega = eye(neq);
prior_df = 10;
prior_df_lower = 1;
prior_df_upper = 20;
%-----------------------------------------



% ڴ趨ʼֵ
beta_rec = zeros(nreg_sum,ndraws-burn_in);
sigma_rec = zeros(neq,neq,ndraws-burn_in);
df_rec = zeros(1,ndraws);

betta = prior_mu + chol(prior_V)'*randn(nreg_sum,1);
inv_sigma = WISHART_RND(prior_omega,prior_df);
df = prior_df_lower + rand*(prior_df_upper-prior_df_lower);

lambda = 1./gamrnd(df/2,2/df,nobs,1);
lambda_sqrt = sqrt(lambda);
lambda_sqrt_mat = lambda_sqrt(:,ones(neq,1))';
lambda_sqrt_vec = lambda_sqrt_mat(:);

resid_mat = zeros(neq,nobs);
X_SUR_sd = zeros(neq*nobs,nreg_sum);
Y_fit_mat = zeros(neq,nobs);

std_jump=1;
success=0;
 
% ⼸Żĳɹ
% ȼѭеɺ㶨ѭз
inv_prior_V = inv(prior_V);
inv_prior_V_mu = inv_prior_V * prior_mu;
inv_prior_omega = inv(prior_omega);
censor_index = Y_mat == 0;

% 濪ʼ˹
H_status_bar = waitbar(0,'In progress   0%');
percentage = floor(ndraws/100);
update_schedule = floor(ndraws/4);
success_lower = 0.15;
success_upper = 0.85;

m = 1;
while m <= ndraws
    
    if mod(m,percentage) == 0
        waitbar(m/ndraws,H_status_bar,['In progress   ',num2str(floor(m/ndraws*100)),'%']);
    end
    
    if m == update_schedule && (success/m < success_lower || success/m > success_upper)
        disp(' ')
        disp(['Jump success ratio:  ',num2str(floor(success/m*100)),'%'])
        disp(['Desirable band ',num2str(success_lower*100),' % ',num2str(success_upper*100), ' %'])
        disp('Desirable band not attained. Sorry, resampling..')
        std_jump=std(df_rec(:,burn_in+1:m-1),0,2);
        m=1;
        success=0;
    end 
    
    % æµֲȡ, ֲ |^2 Ϊ
    % N[inv(X'*inv(I)*X)*(X'*inv(I)Y+inv(V)*mu),inv(X'*inv(I)*X)]    
    % ͨ滯ݼӿִٶ
         
    P = chol(inv_sigma);
    Y_mat_sd = P*Y_mat ./ lambda_sqrt_mat;
    Y_SUR_sd = Y_mat_sd(:);       
        
    X_SUR_sd(1:neq:end,1:nreg_eq(1)) = P(1,1)*X_cell{1} ./ lambda_sqrt(:,ones(nreg_eq(1),1));
    for n=2:neq
        for r=1:n
            X_SUR_sd(r:neq:end,nreg_cum(n-1)+1:nreg_cum(n)) = P(r,n)*X_cell{n}...
                ./ lambda_sqrt(:,ones(nreg_eq(n),1));
        end
    end
        
    beta_prec = X_SUR_sd'*X_SUR_sd+inv_prior_V;
    beta_mean = beta_prec\(X_SUR_sd'*Y_SUR_sd+inv_prior_V_mu);   
    betta = beta_mean + chol(beta_prec)\randn(nreg_sum,1);
    
    % ˦ͦ˵ĳ˳򣬼ӿٶ   
    % æ˵ֲȡ,ֲΪ
    % IG(df+1/2,2*^2/(RSS+df*^2)
    resid_sd = Y_SUR_sd - X_SUR_sd*betta;     
    resid_mat(:) = resid_sd .* lambda_sqrt_vec;
    resid_sigma_resid = sum(resid_mat.^2)';
    
    IG_a = (df+neq)/2;
    IG_b = 2./(df+resid_sigma_resid);
    lambda = 1 ./ gamrnd(IG_a,IG_b);
    lambda_sqrt = sqrt(lambda);
    lambda_sqrt_mat = lambda_sqrt(:,ones(neq,1))';
    lambda_sqrt_vec = lambda_sqrt_mat(:);
    
    % æֲȡ,ֲ | Ϊ
    % W[inv((inv()+RSS_matrix),n+v ]
    % ȽвתΪеĲвټRSS
    Y_fit = X_SUR * betta;
    Y_fit_mat(:) = Y_fit;    
    resid = Y_SUR - Y_fit;    
    resid_mat(:) = resid ./ lambda_sqrt_vec;    
    RSS_matrix = resid_mat * resid_mat';
    post_omega = inv(inv_prior_omega + RSS_matrix);
    inv_sigma = WISHART_RND(post_omega,nobs+prior_df);
    sigma = inv(inv_sigma);
    
    % df M-H
    % ̬Ծܶгѡ
    cand = df + std_jump*randn;
    if cand < prior_df_lower || cand > prior_df_upper
        df_rec(m) = df;
    else        
        pdf_diff_log = (gammaln(df/2) - gammaln(cand/2))*nobs + (df/2*log(2/df) - cand/2*log(2/cand))*nobs...
            +(df-cand)/2 .* sum(log(lambda)+1./lambda);
        if exp(pdf_diff_log) > rand
            df = cand;
            df_rec(m) = cand;
            success = success + 1;        
        else
            df_rec(m) = df;        
        end
    end
    
    % ȡǱڵY*Խضֲ̬
    % ׼, Y*ͷԤ
    % Ԫضֲֲ̬һάضֲ̬
    % ȼ
    seq = true(neq,neq);
    cond_mean_part = cell(neq,1);
    cond_std_part = zeros(neq,1);
    for n = 1:neq        
        seq(n,n) = false;
        seq_use = seq(:,n);
        sigma11 = sigma(n,n);
        sigma12 = sigma(n,seq_use);
        sigma21 = sigma12';
        sigma22 = sigma(seq_use,seq_use);    
        
        cond_mean_part{n} = sigma12/sigma22;
        cond_std_part(n) = sqrt(sigma11 - sigma12/sigma22*sigma21);    
    end
    
    % һһг飨ÿγnobsneq
    for n = 1:neq 
        seq_use = seq(:,n);
        index = censor_index(n,:);
        cond_mean = Y_fit_mat(n,index) + cond_mean_part{n}...
            * ( Y_mat(seq_use,index) - Y_fit_mat(seq_use,index) );
        cond_std = cond_std_part(n) * lambda_sqrt(index);                        
        Y_mat(n,index) = TN_RND_LOWER(cond_mean,cond_std',0);
    end
    Y_SUR = Y_mat(:);
             
    if m>burn_in
        k=m-burn_in;
        beta_rec(:,k)=betta;
        sigma_rec(:,:,k)=inv(inv_sigma);
    end
    
    m=m+1;    
end





% ȥɳʼ
df_rec=df_rec(:,burn_in+1:ndraws);

% ֲ(Ҷ˹)ͱ׼
beta_mean=mean(beta_rec,2);
beta_std=std(beta_rec,0,2);
df_mean=mean(df_rec);
df_std=std(df_rec);
sigma_mean=mean(sigma_rec,3);
sigma_std=std(sigma_rec,0,3);



% ʾƽ

for n=1:neq
    disp(['---------Eq',num2str(n),'estimation-------'])
    result=cell(nreg_eq(n)+1,3);
    result(1,:)={'Variable',' Estimator','  std.  '};
    for m=1:nreg_eq(n)
        result(m+1,1)={['(',num2str(m),')']};
        result(m+1,2:3)={beta_mean(nreg_cum(n)-nreg_cum(1)+m),beta_std(nreg_cum(n)-nreg_cum(1)+m)};
    end
    disp(' ')
    disp(result)
    disp(' ')
end

result=cell(1,3);
result(1,1)={'df '};
result(1,2:3)={df_mean,df_std};
disp(result)
disp(' ')

disp('covariance matrix estimators')
for m=1:neq
    fprintf('%8.2f', sigma_mean(m,:))
    fprintf('\n')
end
fprintf('\n')


close(H_status_bar);
end

% -----------------------------------
% ------ Ӻ TN_RND_LOWER  -------
% -----------------------------------
function output_sample=TN_RND_LOWER(mu,sigma,ub)

% 滯Ͻ磬תΪȡ TN(-,b) (0,1) 
ub=(ub-mu)./sigma;
output_sample=ub;
ub=ub(:);

% ࣬b<-0.6ʱֲָԴܶ, 
%             -0.6<b<0, ֲ̬Դܶ
%             b>0ʱֲ̬Դܶ,
exp_index = ub < -0.6;
norm_index = ub > 0;
half_index = ~exp_index & ~norm_index;

ub_exp=ub(exp_index);
ub_half=ub(half_index);
ub_norm=ub(norm_index);

nexp=length(ub_exp);
nhalf=length(ub_half);
nnorm=length(ub_norm);

% --------------------
% ʼܾb>0ʱֲ̬Դܶ
% ɹ >50% , ֻ1
% (עٶȿ죬Ҫôظ㣬Ҫô)
cand_norm=randn(nnorm,1);
fail= cand_norm > ub_norm;

% ©ȱ
ub_resid=ub_norm(fail);
nresid=length(ub_resid);   
resid=zeros(nresid,1);
for m=1:nresid
    ub_use=ub_resid(m);       
    while 1
        cand=randn;        
        if cand<ub_use
            resid(m)=cand;
            break
        end
    end
end
cand_norm(fail)=resid;
% --------------------


% --------------------
% ʼܾ-0.6<b<0, ֲ̬Դܶ
% ɹ >54% , ֻ1
cand_half=-abs(randn(nhalf,1));
fail= cand_half > ub_half;

% ©ȱ
ub_resid=ub_half(fail);
nresid=length(ub_resid);   
resid=zeros(nresid,1);
for m=1:nresid
    ub_use=ub_resid(m);       
    while 1
        cand=-abs(randn);               
        if cand<ub_use
            resid(m)=cand;
            break
        end
    end
end
cand_half(fail)=resid;

% --------------------

% --------------------
% ʼܾb<-0.6 ʱضֲָԴܶ
% s(x)= *exp(x)*I(x<b)
% Ŧ=0.5*(-b+sqrt(b.^2+4))
% ضֲָ׳飬÷ֲ: 1/*ln(U)+b
% ڳɹʷǳ(>95%)ֻһ
lambda=0.5*(-ub_exp+sqrt(ub_exp.*ub_exp+4));
cand_exp=ub_exp+log(rand(nexp,1))./lambda;
fail= exp(-0.5*(cand_exp+lambda).^2) < rand(nexp,1);

% ©ȱ
ub_resid=ub_exp(fail);
nresid=length(ub_resid); 
if nresid>0    
    lambda_resid=lambda(fail);
    resid=zeros(nresid,1);
    for m=1:nresid
        ub_use=ub_resid(m);
        lambda_use=lambda_resid(m);    
        while 1
            cand=ub_use+log(rand)/lambda_use;
            if exp(-0.5*(cand+lambda_use)^2)>rand
                resid(m)=cand;
                break
            end
        end
    end
    cand_exp(fail)=resid;
end


% ϲ࣬תΪ TN(-,b) (mu, sigma) 
output_sample(exp_index)=cand_exp;
output_sample(half_index)=cand_half;
output_sample(norm_index)=cand_norm;
output_sample=mu+sigma.*output_sample;
end


% -----------------------------------
% ------ Ӻ WISHART_RND  -------
% -----------------------------------
function Wish = WISHART_RND(omega,df)
dim = size(omega,1);
P = chol(omega);
Y = P'*randn(dim,df);
Wish = Y*Y';
end