
function [betta,sigma,df,beta_std,sigma_std,df_std]=ML_CT_SUR(Y1,X1,Y2,X2,Y3,X3,Y4,X4,Y5,X5,Y6,X6,Y7,X7)

% ĹtֲSURϵͳļȻ
% ģԭIG߶Ȼֲ̬ıԵֲtֲ

% Y1             뷽1ͱ,n*1
% X1             뷽1 ͱݣn*kгһΪones(n,1)
% Y2,X2,Y3,X3... 뷽2,3,...(ûҪκζ 
% ע⣺ݳȱȣYi,Xiɶ
%       7޸ĺһУӷ

% betta        Ĺ
% sigma      Э  Ĺ
% df         ɶ df Ĺ

if floor(nargin/2)~=nargin/2
    disp('Error: X,Y not match')
end

% ͶѻSUR(ȶѻ̣ٶѻ)
neq = nargin/2;
nobs = length(Y1);

X_cell = cell(neq,1);
Y_mat = zeros(neq,nobs);
nreg_eq = zeros(neq,1);
for m = 1:neq
    Y_mat(m,:) = eval(['Y',num2str(m)]);
    X_cell{m} = eval(['X',num2str(m)]);
    nreg_eq(m) = length(eval(['X',num2str(m),'(1,:)']));
end
Y_SUR = Y_mat(:);
nreg_cum = cumsum(nreg_eq);
nreg_sum = nreg_cum(end);

X_SUR = zeros(nobs*neq,nreg_sum);
X_use = zeros(neq,nreg_cum(end));
for n = 1:nobs
    X_use(1,1:nreg_eq(1)) = X_cell{1}(n,:);
    for m = 2:neq
        X_use(m,nreg_cum(m-1) + 1:nreg_cum(m)) = X_cell{m}(n,:);
    end
    X_SUR((n-1)*neq + 1:n*neq,:) = X_use;
end


% м
resid_mat = zeros(neq,nobs);

% ԵTOBITΪ׼ѡʼֵ
%beta_0_test = (X_SUR'*X_SUR)\(X_SUR'*Y_SUR);
beta_0 = [];
sigma_0_part = zeros(neq,1);
for m = 1:neq
    [beta_0_part,sigma_0_part(m)] = TOBIT(Y_mat(m,:)',X_cell{m},0,inf);
    beta_0 = [beta_0; beta_0_part];    
end
resid = Y_SUR - X_SUR*beta_0;
resid_mat(:) = resid;
sigma_0 = resid_mat*resid_mat'/nobs;
for m = 1:neq
    sigma_0(m,m) = sigma_0_part(m);
end
df_0 = 5;
para_0 = [beta_0;vech(sigma_0);df_0];
npara = length(para_0);


% --------Ĵ뿪ʼ----------
% ȫݿʼML
estimator = BFGS(@(c)LIKELIHOOD(c,Y_mat,X_SUR),para_0);

% ع
betta=estimator(1:nreg_sum);
sigma=vech(estimator(nreg_sum+1:end-1));
df=estimator(end);

if nargout<4
    return
end

% 㼫ȻƵĽ
% ȻֵBHHHЭ
delta=1e-6;
iota=eye(npara)*delta;
Jocobian=zeros(nobs,npara);
[log_like,log_like_indi]=LIKELIHOOD(estimator,Y_mat,X_SUR);
for m=1:npara    
    [log_like,log_like_indi_sim]=LIKELIHOOD(estimator+iota(:,m),Y_mat,X_SUR);
    Jocobian(:,m)=(log_like_indi_sim-log_like_indi)/delta;
end    
cov_BHHH=inv(Jocobian'*Jocobian);
para_std=sqrt(diag(cov_BHHH));


beta_std=para_std(1:nreg_sum);
sigma_std=vech(para_std(nreg_sum+1:end-1));
df_std=para_std(end);


% ʾƽ
for n=1:neq
    disp(['---------Eq ',num2str(n),'estimation-------'])
    result=cell(nreg_eq(n)+1,3);
    result(1,:)={'Variable',' Estimator','  std.  '};
    for m=1:nreg_eq(n)
        result(m+1,1)={['(',num2str(m),')']};
        result(m+1,2:3)={betta(nreg_cum(n)-nreg_cum(1)+m),beta_std(nreg_cum(n)-nreg_cum(1)+m)};
    end
    disp(' ')
    disp(result)
    disp(' ')
end


disp('covariance matrix estimators')
for m=1:neq
    fprintf('%8.2f', sigma(m,:))
    fprintf('\n')
end
fprintf('\n')

result=cell(2,3);
result(1,:)={'Variable',' Estimator','  std.  '};
result(2,1)={'df'};
result(2,2:3)={df,df_std};
disp(' ')
disp(result)
end

% -------------------------
% -----------------------------------



% -----------------------------------
% ------- Ӻ LIKELIHOOD ---------
% -----------------------------------
function [log_like,log_like_indi] = LIKELIHOOD(c,Y_mat,X_SUR)

% 趨
[neq,nobs] = size(Y_mat);
nreg_sum = length(X_SUR(1,:));

betta = c(1:nreg_sum);
sigma = vech(c(nreg_sum+1:end-1));
df = c(end);

% 󣬷˳
try 
    chol(sigma);
catch
    log_like = -1e10;
    return
end

%--- Ż---
% Ϊؿģ׼ӿٶ
rand('seed',1234567);
randn('seed',12345678);
ndraws = 5000;
tau0 = sqrt(1 ./ gamrnd(df/2,2/df,ndraws,1) );
tau_base = zeros(ndraws,neq-2);
for m = 1:neq-2
    tau_base(:,m) = gamrnd((df+m)/2,2,ndraws,1);
end

% ø˹ֵֵļֵȨ
ngrid=90;
load(['LAGUERRE_RULE_',num2str(ngrid)])
W=W.*exp(tau);  % Gauss-Laguerre Ȩص
W_C=W;
tau_C=tau;

% мظ
constant=gammaln((df+neq)/2)-gammaln(df/2)-0.5*neq*log(pi * df);
P=chol(sigma,'lower');
det_term=-sum(log(diag(P)));


% residY,XҪϢ
Y_SUR = Y_mat(:);
resid = Y_SUR - X_SUR*betta;
resid_mat = zeros(neq,nobs);
resid_mat(:) = resid;

% ʼȻֵ
log_like_indi=zeros(nobs,1);
for m = 1:nobs    
    censor_index = Y_mat(:,m)==0; 
    intact_index = ~censor_index;
    
    resid_censor = resid_mat(censor_index,m);
    resid_intact = resid_mat(intact_index,m);
    
    ncensor = length(resid_censor);
    nintact = neq - ncensor;
    
    
    % Ȼ
    if ncensor == 0
        
        % ݲֲ MVT_PDF_LOG
        X_trans=P\resid_intact;        
        prob_intact = constant + det_term - 0.5*(df+neq) * log(1+X_trans'*X_trans/df);        
        log_like_indi(m) = prob_intact;
        
    elseif ncensor == 1
        
        % 1Gaussֵ
        sigma_cc = sigma(censor_index,censor_index);
        sigma_uu = sigma(intact_index,intact_index);
        sigma_cu = sigma(censor_index,intact_index);
        sigma_uc = sigma(intact_index,censor_index);
        
        cond_mean = resid_censor - sigma_cu*(sigma_uu\resid_intact);
        cond_var = sigma_cc - sigma_cu*(sigma_uu\sigma_uc); 
        norm_part = NORM_CDF(cond_mean./sqrt(cond_var*tau_C));
        
        IG_a = (df + nintact)/2;
        IG_b = 2/ (df + resid_intact'*(sigma_uu\resid_intact)); 
        IG_part = IG_PDF(tau_C,IG_a,IG_b);
        
        prob_censor = log( norm_part .* IG_part * W_C');                
        prob_intact = MVT_PDF_LOG(resid_intact,0,sigma_uu,df);
        log_like_indi(m) = prob_censor + prob_intact;
        
    elseif ncensor < neq
        
        % GHKģ
        sigma_cc = sigma(censor_index,censor_index);
        sigma_uu = sigma(intact_index,intact_index);
        sigma_cu = sigma(censor_index,intact_index);
        sigma_uc = sigma(intact_index,censor_index);            
        
        IG_b = 2/ (df + resid_intact'*(sigma_uu\resid_intact)); 
        tau = sqrt(1 ./ (tau_base(:,nintact)*IG_b/2) );
            
        cond_mean = resid_censor - sigma_cu*(sigma_uu\resid_intact);
        cond_var = sigma_cc - sigma_cu*(sigma_uu\sigma_uc);            
        prob_censor = log(MVT_CDF_DUAL(cond_mean,0,cond_var,df,ndraws,tau));
        prob_intact = MVT_PDF_LOG(resid_intact,0,sigma_uu,df);
        log_like_indi(m) = prob_censor + prob_intact;
    else
        
        % ȫMVTֲˣGHKģ        
        prob_censor = log(MVT_CDF_DUAL(resid_censor,0,sigma,df,ndraws,tau0));
        log_like_indi(m) = prob_censor;
    end
       
    
end

log_like = sum(log_like_indi);

end

% -----------------------------------
% -------    Ӻ vech    ---------
% -----------------------------------
function X_trans=vech(X)

% Ĺǰ뷴
% XΪn*nԳƾ n*(n+1)/2
% XΪ n*(n+1)/2  n*n

[nrow,ncol]=size(X);

if nrow==ncol
    if any(abs(X-X')>1e-6)
        X=X';        
    end
    
    dim=ncol;    
    X_trans=zeros(dim*(dim+1)/2,1);
    k=1;
    for m=1:dim
        for n=m:dim
            X_trans(k)=X(m,n);
            k=k+1;
        end
    end
    return
end

if nrow==1 && ncol>1
    X=X';
    [nrow,ncol]=size(X);
end

if nrow>1 && ncol==1
    dim=floor(sqrt(2*nrow));
    if dim*(dim+1)/2 == nrow
        X_trans=zeros(dim,dim);
        k=1;
        for m=1:dim
            for n=m:dim
                X_trans(m,n)=X(k);
                X_trans(n,m)=X(k);
                k=k+1;
            end
        end
    else
        error('Error')
    end
end

end

% -----------------------------------
% -------   Ӻ MVT_PDF  ---------
% -----------------------------------
function log_density=MVT_PDF_LOG(X,mu,sigma,df)
dim=length(X-mu);
constant=gammaln((df+dim)/2)-gammaln(df/2)-0.5*dim*log(pi * df);
P=chol(sigma,'lower');
det_term=-sum(log(diag(P)));
X_trans=P\(X-mu);
log_density=constant+det_term-0.5*(df+dim) * log(1+X_trans'*X_trans/df);
end

% -----------------------------------
% -------   Ӻ MVT_CDF  ---------
% -----------------------------------
function Prob=MVT_CDF_DUAL(X,mu,sigma,df,ndraws,tau)

rand('seed',1234567);
randn('seed',12345678);

if nargin<5,    ndraws=10000;                               end
if nargin<6,    tau=sqrt(1./gamrnd(df/2,2/df,ndraws,1));    end


% 滯ֵ
X_std=X-mu;
dim=length(X_std);
Y_sim=zeros(ndraws,dim);


% ż
U_core=rand(ndraws/2,dim-1);  
U=[U_core;1-U_core];

% Э˹ֽ
% ΪǾĿǺԼһת÷
P=chol(sigma);

% ǰݹؿģ,ԪֲתΪһԪֲĳ˻
% ˳򣺽ضϵub --> һԪֲ(ub) --> ض̬ Y_sim

% 1ά
ub=X_std(1)/P(1,1)./tau;
prob_sim=NORM_CDF(ub);
Y_sim(:,1)=NORM_INV(U(:,1).*prob_sim);

% 2k-1ά
for m=2:dim-1
    %ub=(X_std(m)./tau-Y_sim*P(:,m))/P(m,m); 
    ub=(X_std(m)./tau-Y_sim(:,1:m-1)*P(1:m-1,m))/P(m,m); 
    CDF=NORM_CDF(ub);
    prob_sim=prob_sim .* CDF;
    Y_sim(:,m)=NORM_INV(U(:,m).*CDF);     
end

% ǵkά
ub=(X_std(end)./tau-Y_sim*P(:,end))/P(end,end);
prob_sim=prob_sim .* NORM_CDF(ub);

% ȡֵǸʵģֵ
Prob=mean(prob_sim);

end


% -----------------------------------
% -------  Ӻ NORM_CDF  ---------
% -----------------------------------
function Prob=NORM_CDF(x)
Prob=0.5 * erfcore(-x / sqrt(2),1);
end


% -----------------------------------
% -------  Ӻ NORM_INV  ---------
% -----------------------------------
function val=NORM_INV(p)
val=-sqrt(2) * erfcore(2*p,4);
end


% -----------------------------------
% -------   Ӻ IG_PDF   ---------
% -----------------------------------
function density=IG_PDF(X,a,b)
log_density=-gammaln(a)-a.*log(b)-(a+1).*log(X)-1./(b.*X);
density=exp(log_density);
end


% -----------------------------------
% -------   Ӻ TOBIT   ---------
% -----------------------------------
function [betta,sigma] = TOBIT(Y,X,censor_lower,censor_upper)
[obs,num_explain]=size(X);
censor_lower_index=(Y==censor_lower);
X_censor_lower=X(censor_lower_index,:);
censor_upper_index=(Y==censor_upper);
X_censor_upper=X(censor_upper_index,:);
continuous_index=logical(1-(censor_lower_index+censor_upper_index));
Y_continous=Y(continuous_index);
X_continous=X(continuous_index,:);
num_continous=length(Y_continous);

% OLSΪ׼ѡʼֵ
coeff_OLS=(X'*X)\(X'*Y);
sigma_OLS=sqrt((Y-X*coeff_OLS)'*(Y-X*coeff_OLS)/obs);
retain_portion=normcdf(censor_upper,mean(X)*coeff_OLS,sigma_OLS)-normcdf(censor_lower,mean(X)*coeff_OLS,sigma_OLS);
c_initial_coeff=coeff_OLS/retain_portion;
c_initial=[c_initial_coeff;sigma_OLS];

% ʼȻ
options = optimset('LargeScale','off','MaxFunEvals',10000,'Display','off'); 
estimator=fminunc(@(c)ML_TOBIT(c,censor_lower,censor_upper,X_censor_lower,X_censor_upper,Y_continous,X_continous,num_explain,num_continous),c_initial,options);
betta = estimator(1:num_explain);
sigma = estimator(num_explain+1).^2;
end

% -----------------------------------
% -------   Ӻ ML_TOBIT   ---------
% -----------------------------------
function log_like=ML_TOBIT(c,censor_lower,censor_upper,X_censor_lower,X_censor_upper,Y_continous,X_continous,num_explain,num_continous)
coeff=c(1:num_explain);
sigma=c(num_explain+1);
if sigma<=0
    log_like=-10000000;
else
    resid=(Y_continous-X_continous*coeff);
    RSS=resid'*resid;
    log_like_continuous=-num_continous*log(sigma)-0.5*RSS/sigma^2;    
    log_like_lower=sum(log(normcdf(censor_lower,X_censor_lower*coeff,sigma)));    
    log_like_upper=sum(log(normcdf(-(censor_upper-X_censor_upper*coeff)/sigma)));    
    log_like=log_like_continuous+log_like_lower+log_like_upper;         
end
log_like=-log_like;
end