function [betta,sigma,df,beta_std,sigma_std,df_std]=EM_CT_SUR(Y1,X1,Y2,X2,Y3,X3,Y4,X4,Y5,X5,Y6,X6,Y7,X7)

% ĹtֲSURϵͳE-M
% ģԭIG߶Ȼֲ̬ıԵֲtֲ
% ȶѻ̣ٶѻ壨ʱ䣩
% Y1             뷽1ͱ,n*1
% X1             뷽1 ͱݣn*kгһΪones(n,1)
% Y2,X2,Y3,X3... 뷽2,3,...(ûҪκζ 
% ע⣺ݳȱȣYi,Xiɶ
%       7޸ĺһУӷ

% 
% betta        Ĺ
% sigma      Э  Ĺ
% df         ɶ df Ĺ



% õ
max_iter = 150;
tol = 1e-10;
ndraws = 5000;
burn_in = ndraws * 0.2;

if floor(nargin/2) ~= nargin/2
    disp('Error: X,Y not match')
end

% ͶѻSUR(ȶѻ̣ٶѻ)
neq = nargin/2;
nobs = length(Y1);

X_cell = cell(neq,1);
Y_mat = zeros(neq,nobs);
nreg_eq = zeros(neq,1);
for m = 1:neq
    Y_mat(m,:) = eval(['Y',num2str(m)]);
    X_cell{m} = eval(['X',num2str(m)]);
    nreg_eq(m) = length(eval(['X',num2str(m),'(1,:)']));
end
Y_SUR = Y_mat(:);
nreg_cum = cumsum(nreg_eq);
nreg_sum = nreg_cum(end);

X_SUR = zeros(nobs*neq,nreg_sum);
X_use = zeros(neq,nreg_cum(end));
for n = 1:nobs
    X_use(1,1:nreg_eq(1)) = X_cell{1}(n,:);
    for m = 2:neq
        X_use(m,nreg_cum(m-1) + 1:nreg_cum(m)) = X_cell{m}(n,:);
    end
    X_SUR((n-1)*neq + 1:n*neq,:) = X_use;
end


% м
resid_mat = zeros(neq,nobs);
censor_index = Y_mat == 0;
X_SUR_sd = X_SUR;
tau_adjust = X_SUR;
Y_mat_sim = Y_mat;
Y_fit_mat = Y_mat;


% ԵTOBITΪ׼ѡʼֵ
betta = [];
sigma_part = zeros(neq,1);
for m = 1:neq
    [beta_part,sigma_part(m)] = TOBIT(Y_mat(m,:)',X_cell{m},0,inf);
    betta = [betta; beta_part];    
end
resid = Y_SUR - X_SUR*betta;
resid_mat(:) = resid;
sigma = resid_mat*resid_mat'/nobs;
for m = 1:neq
    sigma(m,m) = sigma_part(m);
end
df = 5;
para = [betta;vech(sigma);df];
npara = length(para);

tau = gamrnd(df/2, 2/df,nobs,1);




%--------------------
%----Ĵ뿪ʼ----
%--------------------
for m=1:max_iter 
          
    disp(' ')
    disp(['Iteration  ',num2str(m),' in progress'])
    
    % ݹ
    para_temp = para;
    
    %----- E -------
    % ȴǱֲ GIBBS ȡ
    
    % ׼, Y*ͷԤ
    % Ԫضֲֲ̬һάضֲ̬
    % ȼ
    seq = true(neq,neq);
    cond_mean_part = cell(neq,1);
    cond_std_part = zeros(neq,1);
    for n = 1:neq        
        seq(n,n) = false;
        seq_use = seq(:,n);
        sigma11 = sigma(n,n);
        sigma12 = sigma(n,seq_use);
        sigma21 = sigma12';
        sigma22 = sigma(seq_use,seq_use);    
        
        cond_mean_part{n} = sigma12/sigma22;
        cond_std_part(n) = sqrt(sigma11 - sigma12/sigma22*sigma21);    
    end
    
          
    % ٰGibbsѭвıԤȼ
    P = chol(inv(sigma)); 
    Y_fit_mat(:) = X_SUR * betta;
        
    log_tau_sum = 0;
    inv_tau_sum = 0;
    tau_Y_sum = 0; 
    tau_RSS_sum = 0;
    
    for k = 1:ndraws
    
        % ȳY*Խضֲ̬
        % һһг飨ÿγnobsneq
        for n = 1:neq 
            seq_use = seq(:,n);
            index = censor_index(n,:);
            cond_mean = Y_fit_mat(n,index) + cond_mean_part{n}...
                * ( Y_mat_sim(seq_use,index) - Y_fit_mat(seq_use,index) );
            cond_std = cond_std_part(n) * sqrt(tau(index));                        
            Y_mat_sim(n,index) = TN_RND_LOWER(cond_mean,cond_std',0);
        end
        
                       
        % ٳӣԺIGֲ  
        resid_mat = Y_mat_sim - Y_fit_mat;
        resid_mat_trans = P * resid_mat;
        resid_sigma_resid = sum(resid_mat_trans.^2)';
                       
        IG_a = (df + neq)/2;
        IG_b = 2 ./ (df + resid_sigma_resid);
        inv_tau = gamrnd(IG_a, IG_b);              
        tau = 1 ./ inv_tau;
                        
        if k > burn_in
            inv_tau_mat = inv_tau(:,ones(neq,1))';
            log_tau_sum = log_tau_sum + log(tau);
            inv_tau_sum = inv_tau_sum + inv_tau;
            tau_Y_sum = tau_Y_sum + Y_mat_sim .* inv_tau_mat;
            tau_RSS_sum = tau_RSS_sum + resid_mat * (resid_mat.*inv_tau_mat)' / nobs;
        end
    
    end
    
    % Ȼĺ֪ˣ¼ͳ
    E_log_tau = log_tau_sum / (ndraws - burn_in);
    E_inv_tau = inv_tau_sum / (ndraws - burn_in);
    E_Y_tau = tau_Y_sum / (ndraws - burn_in);
    E_RSS_tau = tau_RSS_sum / (ndraws - burn_in);
    
    
    %----- M -------
    % 滯, תΪ chol()*Yt ,  chol()*Xt
    % ΪM׼    
    Y_mat_sd = P * E_Y_tau;
    Y_SUR_sd = Y_mat_sd(:);
    
    X_SUR_sd(1:neq:end,1:nreg_eq(1)) = P(1,1)*X_cell{1};
    for n = 2:neq
        for r = 1:n
            X_SUR_sd(r:neq:end,nreg_cum(n-1)+1:nreg_cum(n)) = P(r,n)*X_cell{n};
        end
    end
       
    temp1 = E_inv_tau';
    temp2 = temp1(ones(nreg_sum*neq,1),:);
    tau_adjust(:) = temp2(:);
    
    
    % E-M² 
    %  
    betta = (X_SUR_sd' * (X_SUR_sd.*tau_adjust)) \ (X_SUR_sd' * Y_SUR_sd);
        
    %  
    sigma = E_RSS_tau;    
       
    %  df
    myfun = @(v) (-gammaln(v/2) + v/2 .* log(v/2) - (v/2+1)*mean(E_log_tau) - v/2*mean(E_inv_tau)); 
    %df = BFGS(myfun,df);
    df_cand = linspace(df-3,df+3,5000);
    [fval_temp,df_index]=max(myfun(df_cand));
    df = df_cand(df_index);
    
    % ܲ
    para = [betta;vech(sigma);df];
    
    
    % ȽԲԣ۲ݵȻֵ
    % Ӧڵвϵ
    %log_like=LIKE_OBS(para,Y_mat,X_SUR);    
    
    % ʾ˳ѭ
    disp(['   =  ',num2str(betta')]) 
    disp(['   =  ',num2str(sigma(:)')]) 
    disp(['df   =  ',num2str(df)]) 
    %disp(['logL =  ',num2str(log_like)])    
          
    distance=(para-para_temp)'*(para-para_temp);
    if distance<tol
        disp(['Congratulations,after ',num2str(m),' iterations, converged!'])
        break
    end
    
end

if nargout<4
    return
end

% 㼫ȻƵĽ
% ȻֵBHHHЭ
delta = 1e-6;
iota = eye(npara)*delta;
Jocobian = zeros(nobs,npara);
[log_like,log_like_indi] = LIKE_OBS(para,Y_mat,X_SUR);
for m=1:npara    
    [log_like,log_like_indi_sim] = LIKE_OBS(para+iota(:,m),Y_mat,X_SUR);
    Jocobian(:,m) = (log_like_indi_sim-log_like_indi)/delta;
end    
cov_BHHH = inv(Jocobian'*Jocobian);
para_std = sqrt(diag(cov_BHHH));
beta_std=para_std(1:nreg_sum);
sigma_std=vech(para_std(nreg_sum+1:end-1));
df_std=para_std(end);


% ʾƽ
for n=1:neq
    disp(['---------Eq ',num2str(n),'estimation-------'])
    result=cell(nreg_eq(n)+1,3);
    result(1,:)={'Variable',' Estimator','  std.  '};
    for m=1:nreg_eq(n)
        result(m+1,1)={['(',num2str(m),')']};
        result(m+1,2:3)={betta(nreg_cum(n)-nreg_cum(1)+m),beta_std(nreg_cum(n)-nreg_cum(1)+m)};
    end
    disp(' ')
    disp(result)
    disp(' ')
end


disp('covariance matrix estimators')
for m=1:neq
    fprintf('%8.2f', sigma(m,:))
    fprintf('\n')
end
fprintf('\n')

result=cell(2,3);
result(1,:)={'Variable',' Estimator','  std.  '};
result(2,1)={'df'};
result(2,2:3)={df,df_std};
disp(' ')
disp(result)

end

% -------------------------
% -----------------------------------



% -----------------------------------
% ----- Ӻ LIKE_OBS -------------
% ۲ֵȻԵԺͱ׼
% -----------------------------------
function [log_like,log_like_indi] = LIKE_OBS(c,Y_mat,X_SUR)

% 趨
[neq,nobs] = size(Y_mat);
nreg_sum = length(X_SUR(1,:));

betta = c(1:nreg_sum);
sigma = vech(c(nreg_sum+1:end-1));
df = c(end);

% 󣬷˳
try 
    chol(sigma);
catch
    log_like=-1e10;
    return
end

%--- Ż---
% Ϊؿģ׼ӿٶ
rand('seed',1234567);
randn('seed',12345678);
ndraws=10000;
tau0 = sqrt(1 ./ gamrnd(df/2,2/df,ndraws,1) );
tau_base = zeros(ndraws,neq-2);
for m = 1:neq-2
    tau_base(:,m) = gamrnd((df+m)/2,2,ndraws,1);
end

% ø˹ֵֵļֵȨ
ngrid=90;
load(['LAGUERRE_RULE_',num2str(ngrid)])
W=W.*exp(tau);  % Gauss-Laguerre Ȩص
W_C=W;
tau_C=tau;

% мظ
constant=gammaln((df+neq)/2)-gammaln(df/2)-0.5*neq*log(pi * df);
P=chol(sigma,'lower');
det_term=-sum(log(diag(P)));


% residY,XҪϢ
Y_SUR = Y_mat(:);
resid = Y_SUR - X_SUR*betta;
resid_mat = zeros(neq,nobs);
resid_mat(:) = resid;

% ʼȻֵ
log_like_indi=zeros(nobs,1);
for m = 1:nobs    
    censor_index = Y_mat(:,m)==0; 
    intact_index = ~censor_index;
    
    resid_censor = resid_mat(censor_index,m);
    resid_intact = resid_mat(intact_index,m);
    
    ncensor = length(resid_censor);
    nintact = neq - ncensor;
    
    
    % Ȼ
    if ncensor == 0
        
        % ݲֲ MVT_PDF_LOG
        X_trans=P\resid_intact;        
        prob_intact = constant + det_term - 0.5*(df+neq) * log(1+X_trans'*X_trans/df);        
        log_like_indi(m) = prob_intact;
        
    elseif ncensor == 1
        
        % 1Gaussֵ
        sigma_cc = sigma(censor_index,censor_index);
        sigma_uu = sigma(intact_index,intact_index);
        sigma_cu = sigma(censor_index,intact_index);
        sigma_uc = sigma(intact_index,censor_index);
        
        cond_mean = resid_censor - sigma_cu*(sigma_uu\resid_intact);
        cond_var = sigma_cc - sigma_cu*(sigma_uu\sigma_uc); 
        norm_part = NORM_CDF(cond_mean./sqrt(cond_var*tau_C));
        
        IG_a = (df + nintact)/2;
        IG_b = 2/ (df + resid_intact'*(sigma_uu\resid_intact)); 
        IG_part = IG_PDF(tau_C,IG_a,IG_b);
        
        prob_censor = log( norm_part .* IG_part * W_C');                
        prob_intact = MVT_PDF_LOG(resid_intact,0,sigma_uu,df);
        log_like_indi(m) = prob_censor + prob_intact;
        
    elseif ncensor < neq
        
        % GHKģ
        sigma_cc = sigma(censor_index,censor_index);
        sigma_uu = sigma(intact_index,intact_index);
        sigma_cu = sigma(censor_index,intact_index);
        sigma_uc = sigma(intact_index,censor_index);            
        
        IG_b = 2/ (df + resid_intact'*(sigma_uu\resid_intact)); 
        tau = sqrt(1 ./ (tau_base(:,nintact)*IG_b/2) );
            
        cond_mean = resid_censor - sigma_cu*(sigma_uu\resid_intact);
        cond_var = sigma_cc - sigma_cu*(sigma_uu\sigma_uc);            
        prob_censor = log(MVT_CDF_DUAL(cond_mean,0,cond_var,df,ndraws,tau));
        prob_intact = MVT_PDF_LOG(resid_intact,0,sigma_uu,df);
        log_like_indi(m) = prob_censor + prob_intact;
    else
        
        % ȫMVTֲˣGHKģ        
        prob_censor = log(MVT_CDF_DUAL(resid_censor,0,sigma,df,ndraws,tau0));
        log_like_indi(m) = prob_censor;
    end
       
    
end

log_like = sum(log_like_indi);

end

% -----------------------------------
% -------    Ӻ vech    ---------
% -----------------------------------
function X_trans=vech(X)

% Ĺǰ뷴
% XΪn*nԳƾ n*(n+1)/2
% XΪ n*(n+1)/2  n*n

[nrow,ncol]=size(X);

if nrow==ncol
    if any(abs(X-X')>1e-6)
        X=X';
        disp('Warning: not postive definite')
    end
    
    dim=ncol;    
    X_trans=zeros(dim*(dim+1)/2,1);
    k=1;
    for m=1:dim
        for n=m:dim
            X_trans(k)=X(m,n);
            k=k+1;
        end
    end
    return
end

if nrow==1 && ncol>1
    X=X';
    [nrow,ncol]=size(X);
end

if nrow>1 && ncol==1
    dim=floor(sqrt(2*nrow));
    if dim*(dim+1)/2 == nrow
        X_trans=zeros(dim,dim);
        k=1;
        for m=1:dim
            for n=m:dim
                X_trans(m,n)=X(k);
                X_trans(n,m)=X(k);
                k=k+1;
            end
        end
    else
        error('Error: mismatched dimension')
    end
end

end

% -----------------------------------
% -------   Ӻ MVT_PDF  ---------
% -----------------------------------
function log_density=MVT_PDF_LOG(X,mu,sigma,df)
dim=length(X-mu);
constant=gammaln((df+dim)/2)-gammaln(df/2)-0.5*dim*log(pi * df);
P=chol(sigma,'lower');
det_term=-sum(log(diag(P)));
X_trans=P\(X-mu);
log_density=constant+det_term-0.5*(df+dim) * log(1+X_trans'*X_trans/df);
end

% -----------------------------------
% -------   Ӻ MVT_CDF  ---------
% -----------------------------------
function Prob=MVT_CDF_DUAL(X,mu,sigma,df,ndraws,tau)

rand('seed',1234567);
randn('seed',12345678);

if nargin<5,    ndraws=10000;                               end
if nargin<6,    tau=sqrt(1./gamrnd(df/2,2/df,ndraws,1));    end


% 滯ֵ
X_std=X-mu;
dim=length(X_std);
Y_sim=zeros(ndraws,dim);


% ż
U_core=rand(ndraws/2,dim-1);  
U=[U_core;1-U_core];

% Э˹ֽ
% ΪǾĿǺԼһת÷
P=chol(sigma);

% ǰݹؿģ,ԪֲתΪһԪֲĳ˻
% ˳򣺽ضϵub --> һԪֲ(ub) --> ض̬ Y_sim

% 1ά
ub=X_std(1)/P(1,1)./tau;
prob_sim=NORM_CDF(ub);
Y_sim(:,1)=NORM_INV(U(:,1).*prob_sim);

% 2k-1ά
for m=2:dim-1
    %ub=(X_std(m)./tau-Y_sim*P(:,m))/P(m,m); 
    ub=(X_std(m)./tau-Y_sim(:,1:m-1)*P(1:m-1,m))/P(m,m); 
    CDF=NORM_CDF(ub);
    prob_sim=prob_sim .* CDF;
    Y_sim(:,m)=NORM_INV(U(:,m).*CDF);     
end

% ǵkά
ub=(X_std(end)./tau-Y_sim*P(:,end))/P(end,end);
prob_sim=prob_sim .* NORM_CDF(ub);

% ȡֵǸʵģֵ
Prob=mean(prob_sim);

end


% -----------------------------------
% -------  Ӻ NORM_CDF  ---------
% -----------------------------------
function Prob=NORM_CDF(x)
Prob=0.5 * erfcore(-x / sqrt(2),1);
end


% -----------------------------------
% -------  Ӻ NORM_INV  ---------
% -----------------------------------
function val=NORM_INV(p)
val=-sqrt(2) * erfcore(2*p,4);
end


% -----------------------------------
% -------   Ӻ IG_PDF   ---------
% -----------------------------------
function density=IG_PDF(X,a,b)
log_density=-gammaln(a)-a.*log(b)-(a+1).*log(X)-1./(b.*X);
density=exp(log_density);
end


% -----------------------------------
% ------ Ӻ TN_RND_LOWER  -------
% -----------------------------------
function output_sample=TN_RND_LOWER(mu,sigma,ub)

% 滯Ͻ磬תΪȡ TN(-,b) (0,1) 
ub=(ub-mu)./sigma;
output_sample=ub;
ub=ub(:);

% ࣬b<-0.6ʱֲָԴܶ, 
%             -0.6<b<0, ֲ̬Դܶ
%             b>0ʱֲ̬Դܶ,
exp_index = ub < -0.6;
norm_index = ub > 0;
half_index = ~exp_index & ~norm_index;

ub_exp=ub(exp_index);
ub_half=ub(half_index);
ub_norm=ub(norm_index);

nexp=length(ub_exp);
nhalf=length(ub_half);
nnorm=length(ub_norm);

% --------------------
% ʼܾb>0ʱֲ̬Դܶ
% ɹ >50% , ֻ1
% (עٶȿ죬Ҫôظ㣬Ҫô)
cand_norm=randn(nnorm,1);
fail= cand_norm > ub_norm;

% ©ȱ
ub_resid=ub_norm(fail);
nresid=length(ub_resid);   
resid=zeros(nresid,1);
for m=1:nresid
    ub_use=ub_resid(m);       
    while 1
        cand=randn;        
        if cand<ub_use
            resid(m)=cand;
            break
        end
    end
end
cand_norm(fail)=resid;
% --------------------


% --------------------
% ʼܾ-0.6<b<0, ֲ̬Դܶ
% ɹ >54% , ֻ1
cand_half=-abs(randn(nhalf,1));
fail= cand_half > ub_half;

% ©ȱ
ub_resid=ub_half(fail);
nresid=length(ub_resid);   
resid=zeros(nresid,1);
for m=1:nresid
    ub_use=ub_resid(m);       
    while 1
        cand=-abs(randn);               
        if cand<ub_use
            resid(m)=cand;
            break
        end
    end
end
cand_half(fail)=resid;

% --------------------

% --------------------
% ʼܾb<-0.6 ʱضֲָԴܶ
% s(x)= *exp(x)*I(x<b)
% Ŧ=0.5*(-b+sqrt(b.^2+4))
% ضֲָ׳飬÷ֲ: 1/*ln(U)+b
% ڳɹʷǳ(>95%)ֻһ
lambda=0.5*(-ub_exp+sqrt(ub_exp.*ub_exp+4));
cand_exp=ub_exp+log(rand(nexp,1))./lambda;
fail= exp(-0.5*(cand_exp+lambda).^2) < rand(nexp,1);

% ©ȱ
ub_resid=ub_exp(fail);
nresid=length(ub_resid); 
if nresid>0    
    lambda_resid=lambda(fail);
    resid=zeros(nresid,1);
    for m=1:nresid
        ub_use=ub_resid(m);
        lambda_use=lambda_resid(m);    
        while 1
            cand=ub_use+log(rand)/lambda_use;
            if exp(-0.5*(cand+lambda_use)^2)>rand
                resid(m)=cand;
                break
            end
        end
    end
    cand_exp(fail)=resid;
end


% ϲ࣬תΪ TN(-,b) (mu, sigma) 
output_sample(exp_index)=cand_exp;
output_sample(half_index)=cand_half;
output_sample(norm_index)=cand_norm;
output_sample=mu+sigma.*output_sample;
end


% -----------------------------------
% -------   Ӻ TOBIT   ---------
% -----------------------------------
function [betta,sigma] = TOBIT(Y,X,censor_lower,censor_upper)
[obs,num_explain]=size(X);
censor_lower_index=(Y==censor_lower);
X_censor_lower=X(censor_lower_index,:);
censor_upper_index=(Y==censor_upper);
X_censor_upper=X(censor_upper_index,:);
continuous_index=logical(1-(censor_lower_index+censor_upper_index));
Y_continous=Y(continuous_index);
X_continous=X(continuous_index,:);
num_continous=length(Y_continous);

% OLSΪ׼ѡʼֵ
coeff_OLS=(X'*X)\(X'*Y);
sigma_OLS=sqrt((Y-X*coeff_OLS)'*(Y-X*coeff_OLS)/obs);
retain_portion=normcdf(censor_upper,mean(X)*coeff_OLS,sigma_OLS)-normcdf(censor_lower,mean(X)*coeff_OLS,sigma_OLS);
c_initial_coeff=coeff_OLS/retain_portion;
c_initial=[c_initial_coeff;sigma_OLS];

% ʼȻ
options = optimset('LargeScale','off','MaxFunEvals',10000,'Display','off'); 
estimator=fminunc(@(c)ML_TOBIT(c,censor_lower,censor_upper,X_censor_lower,X_censor_upper,Y_continous,X_continous,num_explain,num_continous),c_initial,options);
betta = estimator(1:num_explain);
sigma = estimator(num_explain+1).^2;
end

% -----------------------------------
% -------   Ӻ ML_TOBIT   ---------
% -----------------------------------
function log_like=ML_TOBIT(c,censor_lower,censor_upper,X_censor_lower,X_censor_upper,Y_continous,X_continous,num_explain,num_continous)
coeff=c(1:num_explain);
sigma=c(num_explain+1);
if sigma<=0
    log_like=-10000000;
else
    resid=(Y_continous-X_continous*coeff);
    RSS=resid'*resid;
    log_like_continuous=-num_continous*log(sigma)-0.5*RSS/sigma^2;    
    log_like_lower=sum(log(normcdf(censor_lower,X_censor_lower*coeff,sigma)));    
    log_like_upper=sum(log(normcdf(-(censor_upper-X_censor_upper*coeff)/sigma)));    
    log_like=log_like_continuous+log_like_lower+log_like_upper;         
end
log_like=-log_like;
end